import { Result, Scene } from '../serenity/domain';
export declare function nameOf(scenario: ScenarioOrSuite): any;
export declare function categoryOf(scenario: ScenarioOrSuite): any;
export declare function finalStateOf(scenario: ExecutedScenario): Result;
export interface TestError {
    name: string;
    message: string;
    showDiff: boolean;
    actual: string;
    expected: string;
    stack: string;
}
export interface Scenario {
    title: string;
    async: number;
    sync: boolean;
    timedOut: boolean;
    pending: boolean;
    type: string;
    file: string;
    parent: any;
    ctx: any;
    body(): string;
    fullTitle(): string;
}
export interface ExecutedScenario extends Scenario {
    time: any;
    duration: number;
    state: string;
    speed: string;
    err?: TestError;
}
export declare class MochaScene extends Scene {
    constructor(scenario: Scenario);
}
export declare type ScenarioOrSuite = {
    title: string;
    parent: ScenarioOrSuite;
};
