"use strict";
const serenity_1 = require("../../serenity/serenity");
const stage_1 = require("../../serenity/stage");
// todo: implement ProtractorPlugin when https://github.com/angular/protractor/issues/3790 is fixed and I don't need Q
class SerenityProtractorPlugin /* implements ProtractorPlugin */ {
    constructor() {
        this.config = {};
    }
    setup() {
        serenity_1.Serenity.assignCrewMembers(...this.crewMembers());
        return Promise.resolve();
    }
    teardown() {
        return serenity_1.Serenity.stageManager().allDone().then(_ => _, error => {
            console.error('[SerenityProtractorPlugin] An error occurred during teardown', error); // tslint:disable-line:no-console
            return Promise.reject(error);
        });
    }
    crewMembers() {
        return (!!this.config.crew)
            ? this.config.crew
            : [stage_1.jsonReporter()];
    }
}
exports.SerenityProtractorPlugin = SerenityProtractorPlugin;
//# sourceMappingURL=serenity_protractor_plugin.js.map