"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const step_annotation_1 = require("../../../serenity/recording/step_annotation");
const browse_the_web_1 = require("../abilities/browse_the_web");
const hit_1 = require("./hit");
class Enter {
    constructor(value) {
        this.value = value;
        this.interactions = [];
    }
    static theValue(value) {
        return new Enter(value);
    }
    into(field) {
        this.target = field;
        this.interactions.push(new EnterValue(this.value, field));
        return this;
    }
    thenHit(key) {
        this.interactions.push(hit_1.Hit.the(key).into(this.target));
        return this;
    }
    performAs(actor) {
        return actor.attemptsTo(...this.interactions);
    }
}
exports.Enter = Enter;
class EnterValue {
    constructor(value, target) {
        this.value = value;
        this.target = target;
    }
    performAs(actor) {
        return browse_the_web_1.BrowseTheWeb.as(actor).locate(this.target).sendKeys(this.value);
    }
}
__decorate([
    step_annotation_1.step('{0} enters "#value" into #target'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Object)
], EnterValue.prototype, "performAs", null);
//# sourceMappingURL=enter.js.map