"use strict";
const protractor_1 = require("protractor");
const browse_the_web_1 = require("../abilities/browse_the_web");
class Select {
    static theValue(value) {
        return { from: (target) => new SelectOption(value, target) };
    }
    static values(...values) {
        return { from: (target) => new SelectOptions(values, target) };
    }
}
exports.Select = Select;
class SelectOption {
    constructor(value, target) {
        this.value = value;
        this.target = target;
    }
    performAs(actor) {
        return browse_the_web_1.BrowseTheWeb.as(actor)
            .locate(this.target)
            .element(protractor_1.by.cssContainingText('option', this.value))
            .click();
    }
}
class SelectOptions {
    constructor(values, target) {
        this.values = values;
        this.target = target;
    }
    performAs(actor) {
        const hasRequiredText = (option) => option.getText().then(value => !!~this.values.indexOf(value)), isAlreadySelected = (option) => option.isSelected(), ensureOnlyOneApplies = (list) => list.filter(_ => _ === true).length === 1, select = (option) => option.click();
        const optionsToClick = (option) => Promise.all([
            hasRequiredText(option),
            isAlreadySelected(option),
        ])
            .then(ensureOnlyOneApplies);
        return browse_the_web_1.BrowseTheWeb.as(actor).locate(this.target)
            .all(protractor_1.by.css('option'))
            .filter(optionsToClick)
            .each(select);
    }
}
//# sourceMappingURL=select.js.map