"use strict";
const browse_the_web_1 = require("../abilities/browse_the_web");
class Attribute {
    constructor(target) {
        this.target = target;
    }
    static of(target) {
        return new Attribute(target);
    }
    called(name) {
        return new AttributeValue(this.target, name);
    }
}
exports.Attribute = Attribute;
class AttributeValue {
    constructor(target, attribute) {
        this.target = target;
        this.attribute = attribute;
        this.toString = () => `the value of the '${this.attribute}' attribute of ${this.target}`;
    }
    answeredBy(actor) {
        return browse_the_web_1.BrowseTheWeb.as(actor).locate(this.target).getAttribute(this.attribute);
    }
}
//# sourceMappingURL=attribute.js.map