"use strict";
const browse_the_web_1 = require("../abilities/browse_the_web");
class Text {
    static of(element) {
        return new TextOf(element);
    }
    static ofAll(elements) {
        return new TextOfAll(elements);
    }
}
exports.Text = Text;
class TextOf {
    constructor(target) {
        this.target = target;
        this.toString = () => `the text of ${this.target}`;
    }
    answeredBy(actor) {
        return browse_the_web_1.BrowseTheWeb.as(actor).locate(this.target).getText();
    }
}
class TextOfAll {
    constructor(target) {
        this.target = target;
        this.toString = () => `the text of all ${this.target}`;
    }
    answeredBy(actor) {
        // protractor ignores type definitions for the ElementArrayFinder
        // https://github.com/angular/protractor/blob/c3978ec166760ac07db01e700c4aaaa19d9b5c38/lib/element.ts#L92
        return browse_the_web_1.BrowseTheWeb.as(actor).locateAll(this.target).getText();
    }
}
//# sourceMappingURL=text.js.map