"use strict";
const moment = require("moment");
class DomainEvent {
    constructor(value, timestamp) {
        this.value = value;
        this.timestamp = timestamp;
        this.timestamp = timestamp || moment().valueOf();
        this.type = this.constructor.name;
    }
    toString() {
        return `${this.timestamp} | ${this.constructor.name}: ${this.value.toString()}`;
    }
}
exports.DomainEvent = DomainEvent;
class SceneStarts extends DomainEvent {
}
exports.SceneStarts = SceneStarts;
class ActivityStarts extends DomainEvent {
}
exports.ActivityStarts = ActivityStarts;
class ActivityFinished extends DomainEvent {
}
exports.ActivityFinished = ActivityFinished;
class SceneFinished extends DomainEvent {
}
exports.SceneFinished = SceneFinished;
class PhotoAttempted extends DomainEvent {
}
exports.PhotoAttempted = PhotoAttempted;
//# sourceMappingURL=events.js.map