"use strict";
const events_1 = require("../domain/events");
const moment = require("moment");
const util = require("util");
function consoleReporter(print = console.log) {
    return new ConsoleReporter(print);
}
exports.consoleReporter = consoleReporter;
class ConsoleReporter {
    constructor(print) {
        this.print = print;
    }
    assignTo(stage) {
        this.stage = stage;
        this.stage.manager.registerInterestIn(ConsoleReporter.Events_of_Interest, this);
    }
    notifyOf(event) {
        this.print(util.format('%s | %s: %s', moment(event.timestamp).format('HH:mm:ss.SSS'), event.constructor.name, event.value));
    }
}
ConsoleReporter.Events_of_Interest = [events_1.DomainEvent];
exports.ConsoleReporter = ConsoleReporter;
//# sourceMappingURL=console_reporter.js.map