"use strict";
class Stage {
    constructor(manager) {
        this.manager = manager;
    }
    enter(cast) {
        this.cast = cast;
        return this;
    }
    theActorCalled(actorName) {
        if (!this.castIsReady()) {
            throw new Error('The cast has not entered the stage yet.');
        }
        this.actorInTheSpotlight = this.cast.actor(actorName);
        return this.actorInTheSpotlight;
    }
    theShowHasStarted() {
        return !!this.actorInTheSpotlight;
    }
    theActorInTheSpotlight() {
        if (!this.theShowHasStarted()) {
            throw new Error('There\'s no actor in the spotlight yet.');
        }
        return this.actorInTheSpotlight;
    }
    castIsReady() {
        return !!this.cast;
    }
}
exports.Stage = Stage;
//# sourceMappingURL=stage.js.map